/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

/*
 * Created on Apr 11, 2005
 *
 */
package com.sunlabs.archsim.fleet.common;

import com.sunlabs.archsim.base.simulation.Delay;

/**
 * @author ib27688
 *
 */
public class FleetGlobal {

	/** never make an instance of this class */
	private FleetGlobal() {}
	
	public static final Delay INSTRUCTION_SOURCE_DELAY= new Delay(0);
	
	public static final Delay DEFAULT_FUNCTION_DELAY= new Delay(10);
	
	public static boolean LOG_SHIP_SOURCE= false;
	public static boolean LOG_SHIP_SINK= true;
	public static boolean LOG_INSTRUCTION_SOURCE= false;
	public static boolean LOG_TRUNK= false;
		
	
	public static final String IN= "In";
	public static final String ACK_IN= "ackIn";
	
	public static final String OUT= "Out";
	public static final String ACK_OUT= "ackOut";	
	
	public static final String DATA_STATE= "dataState";
	public static final String ACK_STATE= "ackState";
	
	public static final String BRANCH_ACTION= "branchAction";
	public static final String BRANCH= "branch";	
	
	public static final String SRC_SYNC= "SrcSync";
	public static final String MERGE= "merge";
	
	public static final String SRC_IN= "SrcIn";
	public static final String ACK_SRC_IN= "ackSrcIn";

	public static final String SINK= "sink";
	public static final String SOURCE= "source";

	public static final String TOKEN_IN= "TokenIn";
	public static final String ACK_TOKEN_IN= "ackTokenIn";
	
	public static final String TOKEN_OUT= "TokenOut";
	public static final String ACK_TOKEN_OUT= "ackTokenOut";
	
	public static final String TOKEN_STATE= "tokenState";
	public static final String ACK_TOKEN_STATE= "ackTokenState";

	public static final String DELIMITER= "_";
	
	public static final String PARAMETER= "parameter";
	
	
} // FleetGlobal
