/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

package com.sunlabs.archsim.fleet.ships.stride;

import com.sunlabs.archsim.base.simulation.Delay;
import com.sunlabs.archsim.engine.Director;

import junit.framework.TestCase;
import junit.textui.TestRunner;

public class StrideJUTest extends TestCase {
	
	public StrideJUTest(String arg){
		super(arg);
	} // constructor
	
	public void setUp() {
		
	}
	
	public void tearDown() {
		Director.getInstance().masterClear();
	}
	
	public static void main(String[] args) {
		TestRunner.run(StrideJUTest.class);
	}
	
	public void testStride() {
		// System.out.println("testStride");
		
		Director director= Director.getInstance();
		
		StrideTest strideTest= new StrideTest("JUStrideTest");
		
		// run self-check
		Boolean selfCheck= strideTest.selfCheck();
		assertTrue(selfCheck);
		
		// run the rest of the test only if self-check passed
		if (selfCheck) {
			director.reset();
			// run for long enough to go through all the tests
			director.run(new Delay(10000));
			boolean testsPassed= strideTest.testCheck();
			assertTrue(testsPassed);
		}
	}

} // class TestCase
