/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

/*
 * Created on Mar 24, 2005
 *
 */
package com.sunlabs.archsim.tests.branch;

import com.sunlabs.archsim.base.hierarchy.CompositeEntity;
import com.sunlabs.archsim.base.simulation.Delay;
import com.sunlabs.archsim.fleet.common.Data;
import com.sunlabs.archsim.fleet.common.Payload;
import com.sunlabs.archsim.gasp.Function;
import com.sunlabs.archsim.gasp.TriggerAction;


/**
 * @author ib27688
 *
 */
public class BranchTestSource extends TriggerAction {
	
	private GenerateData function;
	
	public BranchTestSource(String name, int start, int  count) {
		super(name);
		function= new GenerateData(start, count);
		outputFunctions.put(BranchTestGlobal.SRC_OUT, function);
		
		// start as enabled
		enabled= true;
	} // FifoAction

	public BranchTestSource(String name, int start, int count, CompositeEntity g) {
		this(name, start, count);
		g.addMember(this);
	}
	
	
	/** set the sink delay */
	public void setDelay(Delay d) {
		function.setDelay(d);
	}	
	
	/** Generate new data items */
	private class GenerateData extends Function {

		private int next;
		private int count;
		
		public GenerateData(int start, int cnt) {
			super("GenerateData");
			next= start;
			count= cnt;
			functionDelay= BranchTestGlobal.SOURCE_DELAY;
		}
		
		public Object value() {
			if (BranchTestGlobal.sourceDisplayGenerated) {
				director.journal("Source " + getName() 
						+ " generated " + next);
			}
			Data d= new Data(next++);
			Payload p= new Payload();
			p.data= d;
			
			if (next >= count) {
				// the source has done its job
				enabled= false;
			}
			
			return p;	
		} // value
	} // PassData

} // BranchTestSource
